

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif
#include "Metro.h"

Metro::Metro()
{
	this->interval_millis = 1000;
	this->enabled = false;                           // modification by  ETK
	
}

Metro::Metro(unsigned long interval_millis)
{
	this->interval_millis = interval_millis;
	reset();                           // modification by  ETK
}

void Metro::interval(unsigned long interval_millis)
{
  this->interval_millis = interval_millis;
  reset();                           // modification by  ETK
}

bool Metro::check()
{ 
                                        // modification by  ETK
  if ( ! this->enabled ) return false;  // if timer is not running, return false
  
  unsigned long now = millis();
  
  if ( interval_millis == 0 ){
    previous_millis = now;
	return true;
  }
 
  if ( (now - previous_millis) >= interval_millis) {
	#ifdef NOCATCH-UP
	previous_millis = now ; 
	#else
	previous_millis += interval_millis ; 
	 #endif
    return true;
  }
  
  return false;
}

void Metro::reset() 
{
  this->previous_millis = millis();
  this->enabled = true;                           // modification by  ETK
}

bool Metro::isEnabled()                            // modification by  ETK
{
  return enabled;
}

void Metro::enable()                            // modification by  ETK
{
  reset();
}

void Metro::disable()                            // modification by  ETK
{
  this->enabled = false;
}


