// This code will blink output 13 every 250 ms
// abd will blink output 9 every 125 ms


#include <Metro.h> // Include Metro library
#define LED1 13 // Define a LED pin
#define LED2 9 // Define another LED pin

// Create variables to hold the LED states
int state1 = HIGH;
int state2 = HIGH;

uint32_t time1 = 250;
uint32_t time2 = 125;

// Instantiate 2 metro objects 
Metro timer_1; 
Metro timer_2; 

//====================================================================================
void setup() {
  
  pinMode(LED1,OUTPUT);
  digitalWrite(LED1,state1);
  
  pinMode(LED2,OUTPUT);
  digitalWrite(LED2,state2);
  
  Serial.begin(9600);
  delay(500);
  Serial.println("[blinking_2_instances]");
  Serial.print("Metro library version: "); Serial.println(Metro_VERSION);
  Serial.println("Demonstrates the use of the Metro library using two timers.\n");
  
  Serial.print("Start blinking pin 13 at a rate of "); Serial.print(time1); Serial.println(" ms ..."); 
  Serial.print("Start blinking pin  9 at a rate of "); Serial.print(time2); Serial.println(" ms ..."); 
  
  timer_1 = Metro(time1);      // start the timers
  timer_2 = Metro(time2); 
}

//====================================================================================
void loop() {

  if (timer_1.check()) { // check if the metro-0 has passed its interval .
    if (state1==HIGH)  { 
      state1=LOW;
    } else {
      state1=HIGH;
    }
    digitalWrite(LED1,state1);
  }
  
   if (timer_2.check()) { // check if the metro-1 has passed its interval .
    if (state2==HIGH)  { 
      state2=LOW;
    } else {
      state2=HIGH;
    }
    digitalWrite(LED2,state2);
  }

}
